#include"sorting.h"


void merge(vector<int>& v, int first, int mid, int last)
{
  // temporary vector to merge the sorted sublists
  vector<int> tempVector;
  int indexA, indexB, indexV;
  
  // set indexA to scan sublistA (index range [first,mid)
  // and indexB to scan sublistB (index range [mid, last)
  indexA = first;
  indexB = mid;
  
  // while both sublists are not exhausted, compare v[indexA] and
  // v[indexB]copy the smaller to vector temp using push_back()
  while (indexA < mid && indexB < last)
    if (v[indexA] < v[indexB])
      {
        tempVector.push_back(v[indexA]);    // copy element to temp
        indexA++;                           // increment indexA
      }
    else
      {
        tempVector.push_back(v[indexB]);    // copy element to temp
        indexB++;                           // increment indexB
      }
  
  // copy the tail of the sublist that is not exhausted
  while (indexA < mid)
    {
      tempVector.push_back(v[indexA]);
      indexA++;
    }
  
  while (indexB < last)
    {
      tempVector.push_back(v[indexB]);
      indexB++;
    }
  
  // copy vector tempVector using indexV to vector v using indexA
  // which is initially set to first
  indexA = first;
  
  // copy elements from temporary vector to original list
  for (indexV = 0; indexV < tempVector.size(); indexV++)
    {
      v[indexA] = tempVector [indexV];
      indexA++;
    }
}

vector<int> sort_custom (vector<int>
 v, int first, int last)
{
  // if the sublist has more than 1 element continue
  if (first + 1 < last)
    {
      // for sublists of size 2 or more, call mergeSort()
      // for the left and right sublists and then
      // merge the sorted sublists using merge()
      int midpt = (last + first) / 2;
      
      sort_custom(v, first, midpt);
      sort_custom(v, midpt, last);
      merge(v, first, midpt, last);
    }
 return v;
}